Scala Standard Library2.12.2-20170504-135222-21d12e9 < Back
 

# Packages

-  package root

  This is the documentation for the Scala standard library.

  This is the documentation for the Scala standard library.

  #### Package structure

  The scala package contains core types like `Int`, `Float`, `Array` or `Option` which are accessible in all Scala compilation units without explicit qualification or imports.

  Notable packages include:

  - `scala.collection` and its sub-packages contain Scala's collections framework
    - `scala.collection.immutable` - Immutable, sequential data-structures such as `Vector`, `List`, `Range`, `HashMap` or `HashSet`
    - `scala.collection.mutable` - Mutable, sequential data-structures such as `ArrayBuffer`, `StringBuilder`, `HashMap` or `HashSet`
    - `scala.collection.concurrent` - Mutable, concurrent data-structures such as `TrieMap`
    - `scala.collection.parallel.immutable` - Immutable, parallel data-structures such as `ParVector`, `ParRange`, `ParHashMap` or `ParHashSet`
    - `scala.collection.parallel.mutable` - Mutable, parallel data-structures such as `ParArray`, `ParHashMap`, `ParTrieMap` or `ParHashSet`
  - `scala.concurrent` - Primitives for concurrent programming such as `Futures` and `Promises`
  - `scala.io` - Input and output operations
  - `scala.math` - Basic math functions and additional numeric types like `BigInt` and `BigDecimal`
  - `scala.sys` - Interaction with other processes and the operating system
  - `scala.util.matching` - Regular expressions

  Other packages exist. See the complete list on the right.

  Additional parts of the standard library are shipped as separate libraries. These include:

  - `scala.reflect` - Scala's reflection API (scala-reflect.jar)
  - `scala.xml` - XML parsing, manipulation, and serialization (scala-xml.jar)
  - `scala.swing` - A convenient wrapper around Java's GUI framework called Swing (scala-swing.jar)
  - `scala.util.parsing` - Parser combinators (scala-parser-combinators.jar)

  #### Automatic imports

  Identifiers in the scala package and the `scala.Predef` object are always in scope by default.

  Some of these identifiers are type aliases provided as shortcuts to commonly used classes. For example, `List` is an alias for `scala.collection.immutable.List`.

  Other aliases refer to classes provided by the underlying platform. For example, on the JVM, `String` is an alias for `java.lang.String`.

  Definition Classes
    root
-  package scala

  Core Scala types.

  Core Scala types. They are always available without an explicit import.

  Definition Classes
    root
-  abstract class Enumeration extends Serializable

  Defines a finite set of values specific to the enumeration.

  Defines a finite set of values specific to the enumeration. Typically these values enumerate all possible forms something can take and provide a lightweight alternative to case classes.

  Each call to a `Value` method adds a new unique value to the enumeration. To be accessible, these values are usually defined as `val` members of the evaluation.

  All values in an enumeration share a common, unique type defined as the `Value` type member of the enumeration (`Value` selected on the stable identifier path of the enumeration instance).

  Definition Classes
    scala
  Annotations
    @SerialVersionUID()
  Example:

  1.     object Main extends App {

           object WeekDay extends Enumeration {
             type WeekDay = Value
             val Mon, Tue, Wed, Thu, Fri, Sat, Sun = Value
           }
           import WeekDay._

           def isWorkingDay(d: WeekDay) = ! (d == Sat || d == Sun)

           WeekDay.values filter isWorkingDay foreach println
         }
         // output:
         // Mon
         // Tue
         // Wed
         // Thu
         // Fri

- Val
- Value
- ValueOrdering
- ValueSet

c

scala.Enumeration

# Value 

###

#### abstract class Value extends Ordered[Value] with Serializable

The type of the enumerated values.

Annotations
  @SerialVersionUID()
Source
  Enumeration.scala

Linear Supertypes
Serializable, java.io.Serializable, math.Ordered[Value], Comparable[Value], AnyRef, Any
Known Subclasses
Val
Type Hierarchy
 
Ordering

1. Alphabetic
2. By Inheritance

Inherited

1. Value
2. Serializable
3. Serializable
4. Ordered
5. Comparable
6. AnyRef
7. Any

Implicitly

1. by orderingToOrdered
2. by any2stringadd
3. by StringFormat
4. by Ensuring
5. by ArrowAssoc

1. Hide All
2. Show All

Visibility

1. Public
2. All

### Instance Constructors

1.  new Value()

### Abstract Value Members

1.  abstract def id: Int

   the id and bit location of this enumeration value

### Concrete Value Members

1.  final def !=(arg0: Any): Boolean

   Test two objects for inequality.

   Test two objects for inequality.

   returns

     `true` if !(this == that), false otherwise.

   Definition Classes
     AnyRef → Any
2.  final def ##(): Int

   Equivalent to `x.hashCode` except for boxed numeric types and `null`.

   Equivalent to `x.hashCode` except for boxed numeric types and `null`. For numerics, it returns a hash value which is consistent with value equality: if two value type instances compare as true, then ## will produce the same hash value for each of them. For `null` returns a hashcode where `null.hashCode` throws a `NullPointerException`.

   returns

     a hash value consistent with ==

   Definition Classes
     AnyRef → Any
3.  def +(v: Value): ValueSet

   Create a ValueSet which contains this value and another one

4.  def ->[B](y: B): (Value, B)
   Implicit
     This member is added by an implicit conversion from Value to ArrowAssoc[Value] performed by method ArrowAssoc in scala.Predef.
   Definition Classes
     ArrowAssoc
   Annotations
     @inline()
5.  def <(that: Value): Boolean

   Returns true if `this` is less than `that`

   Returns true if `this` is less than `that`

   Definition Classes
     Ordered
6.  def <=(that: Value): Boolean

   Returns true if `this` is less than or equal to `that`.

   Returns true if `this` is less than or equal to `that`.

   Definition Classes
     Ordered
7.  final def ==(arg0: Any): Boolean

   The expression `x == that` is equivalent to `if (x eq null) that eq null else x.equals(that)`.

   The expression `x == that` is equivalent to `if (x eq null) that eq null else x.equals(that)`.

   returns

     `true` if the receiver object is equivalent to the argument; `false` otherwise.

   Definition Classes
     AnyRef → Any
8.  def >(that: Value): Boolean

   Returns true if `this` is greater than `that`.

   Returns true if `this` is greater than `that`.

   Definition Classes
     Ordered
9.  def >=(that: Value): Boolean

   Returns true if `this` is greater than or equal to `that`.

   Returns true if `this` is greater than or equal to `that`.

   Definition Classes
     Ordered
10.  final def asInstanceOf[T0]: T0

    Cast the receiver object to be of type `T0`.

    Cast the receiver object to be of type `T0`.

    Note that the success of a cast at runtime is modulo Scala's erasure semantics. Therefore the expression `1.asInstanceOf[String]` will throw a `ClassCastException` at runtime, while the expression `List(1).asInstanceOf[List[String]]` will not. In the latter example, because the type argument is erased as part of compilation it is not possible to check whether the contents of the list are of the requested type.

    returns

      the receiver object.

    Definition Classes
      Any
    Exceptions thrown

      `ClassCastException` if the receiver object is not an instance of the erasure of type `T0`.

11.  def clone(): AnyRef

    Create a copy of the receiver object.

    Create a copy of the receiver object.

    The default implementation of the `clone` method is platform dependent.

    returns

      a copy of the receiver object.

    Attributes
      protected[java.lang]
    Definition Classes
      AnyRef
    Annotations
      @throws( ... )
    Note

      not specified by SLS as a member of AnyRef

12.  def compare(that: Value): Int

    Result of comparing `this` with operand `that`.

    Result of comparing `this` with operand `that`.

    Implement this method to determine how instances of A will be sorted.

    Returns `x` where:

    - `x < 0` when `this < that`
    - `x == 0` when `this == that`
    - `x > 0` when `this > that`
    Definition Classes
      Value → Ordered
13.  def compareTo(that: Value): Int

    Result of comparing `this` with operand `that`.

    Result of comparing `this` with operand `that`.

    Definition Classes
      Ordered → Comparable
14.  def ensuring(cond: (Value) ⇒ Boolean, msg: ⇒ Any): Value
    Implicit
      This member is added by an implicit conversion from Value to Ensuring[Value] performed by method Ensuring in scala.Predef.
    Definition Classes
      Ensuring
15.  def ensuring(cond: (Value) ⇒ Boolean): Value
    Implicit
      This member is added by an implicit conversion from Value to Ensuring[Value] performed by method Ensuring in scala.Predef.
    Definition Classes
      Ensuring
16.  def ensuring(cond: Boolean, msg: ⇒ Any): Value
    Implicit
      This member is added by an implicit conversion from Value to Ensuring[Value] performed by method Ensuring in scala.Predef.
    Definition Classes
      Ensuring
17.  def ensuring(cond: Boolean): Value
    Implicit
      This member is added by an implicit conversion from Value to Ensuring[Value] performed by method Ensuring in scala.Predef.
    Definition Classes
      Ensuring
18.  final def eq(arg0: AnyRef): Boolean

    Tests whether the argument (`that`) is a reference to the receiver object (`this`).

    Tests whether the argument (`that`) is a reference to the receiver object (`this`).

    The `eq` method implements an equivalence relation on non-null instances of `AnyRef`, and has three additional properties:

    - It is consistent: for any non-null instances `x` and `y` of type `AnyRef`, multiple invocations of `x.eq(y)` consistently returns `true` or consistently returns `false`.
    - For any non-null instance `x` of type `AnyRef`, `x.eq(null)` and `null.eq(x)` returns `false`.
    - `null.eq(null)` returns `true`.

    When overriding the `equals` or `hashCode` methods, it is important to ensure that their behavior is consistent with reference equality. Therefore, if two objects are references to each other (`o1 eq o2`), they should be equal to each other (`o1 == o2`) and they should hash to the same value (`o1.hashCode == o2.hashCode`).

    returns

      `true` if the argument is a reference to the receiver object; `false` otherwise.

    Definition Classes
      AnyRef
19.  def equals(other: Any): Boolean

    The equality method for reference types.

    The equality method for reference types. Default implementation delegates to `eq`.

    See also `equals` in scala.Any.

    returns

      `true` if the receiver object is equivalent to the argument; `false` otherwise.

    Definition Classes
      Value → AnyRef → Any
20.  def finalize(): Unit

    Called by the garbage collector on the receiver object when there are no more references to the object.

    Called by the garbage collector on the receiver object when there are no more references to the object.

    The details of when and if the `finalize` method is invoked, as well as the interaction between `finalize` and non-local returns and exceptions, are all platform dependent.

    Attributes
      protected[java.lang]
    Definition Classes
      AnyRef
    Annotations
      @throws( classOf[java.lang.Throwable] )
    Note

      not specified by SLS as a member of AnyRef

21.  def formatted(fmtstr: String): String

    Returns string formatted according to given `format` string.

    Returns string formatted according to given `format` string. Format strings are as for `String.format` (@see java.lang.String.format).

    Implicit
      This member is added by an implicit conversion from Value to StringFormat[Value] performed by method StringFormat in scala.Predef.
    Definition Classes
      StringFormat
    Annotations
      @inline()
22.  final def getClass(): Class[_]

    Returns the runtime class representation of the object.

    Returns the runtime class representation of the object.

    returns

      a class object corresponding to the runtime type of the receiver.

    Definition Classes
      AnyRef → Any
23.  def hashCode(): Int

    The hashCode method for reference types.

    The hashCode method for reference types. See hashCode in scala.Any.

    returns

      the hash code value for this object.

    Definition Classes
      Value → AnyRef → Any
24.  final def isInstanceOf[T0]: Boolean

    Test whether the dynamic type of the receiver object is `T0`.

    Test whether the dynamic type of the receiver object is `T0`.

    Note that the result of the test is modulo Scala's erasure semantics. Therefore the expression `1.isInstanceOf[String]` will return `false`, while the expression `List(1).isInstanceOf[List[String]]` will return `true`. In the latter example, because the type argument is erased as part of compilation it is not possible to check whether the contents of the list are of the specified type.

    returns

      `true` if the receiver object is an instance of erasure of type `T0`; `false` otherwise.

    Definition Classes
      Any
25.  final def ne(arg0: AnyRef): Boolean

    Equivalent to `!(this eq that)`.

    Equivalent to `!(this eq that)`.

    returns

      `true` if the argument is not a reference to the receiver object; `false` otherwise.

    Definition Classes
      AnyRef
26.  final def notify(): Unit

    Wakes up a single thread that is waiting on the receiver object's monitor.

    Wakes up a single thread that is waiting on the receiver object's monitor.

    Definition Classes
      AnyRef
    Note

      not specified by SLS as a member of AnyRef

27.  final def notifyAll(): Unit

    Wakes up all threads that are waiting on the receiver object's monitor.

    Wakes up all threads that are waiting on the receiver object's monitor.

    Definition Classes
      AnyRef
    Note

      not specified by SLS as a member of AnyRef

28.  final def synchronized[T0](arg0: ⇒ T0): T0
    Definition Classes
      AnyRef
29.  def toString(): String

    Creates a String representation of this object.

    Creates a String representation of this object. The default representation is platform dependent. On the java platform it is the concatenation of the class name, "@", and the object's hashcode in hexadecimal.

    returns

      a String representation of the object.

    Definition Classes
      AnyRef → Any
30.  final def wait(): Unit
    Definition Classes
      AnyRef
    Annotations
      @throws( ... )
31.  final def wait(arg0: Long, arg1: Int): Unit
    Definition Classes
      AnyRef
    Annotations
      @throws( ... )
32.  final def wait(arg0: Long): Unit
    Definition Classes
      AnyRef
    Annotations
      @throws( ... )
33.  def →[B](y: B): (Value, B)
    Implicit
      This member is added by an implicit conversion from Value to ArrowAssoc[Value] performed by method ArrowAssoc in scala.Predef.
    Definition Classes
      ArrowAssoc

### Shadowed Implicit Value Members

1.  def +(other: String): String
   Implicit
     This member is added by an implicit conversion from Value to any2stringadd[Value] performed by method any2stringadd in scala.Predef.
   Shadowing
     This implicitly inherited member is shadowed by one or more members in this class.
     To access this member you can use a type ascription:

         (value: any2stringadd[Value]).+(other)

   Definition Classes
     any2stringadd
2.  def <(that: Value): Boolean

   Returns true if `this` is less than `that`

   Returns true if `this` is less than `that`

   Implicit
     This member is added by an implicit conversion from Value to math.Ordered[Value] performed by method orderingToOrdered in scala.math.Ordered. This conversion will take place only if an implicit value of type math.Ordering[Value] is in scope.
   Shadowing
     This implicitly inherited member is shadowed by one or more members in this class.
     To access this member you can use a type ascription:

         (value: math.Ordered[Value]).<(that)

   Definition Classes
     Ordered
3.  def <=(that: Value): Boolean

   Returns true if `this` is less than or equal to `that`.

   Returns true if `this` is less than or equal to `that`.

   Implicit
     This member is added by an implicit conversion from Value to math.Ordered[Value] performed by method orderingToOrdered in scala.math.Ordered. This conversion will take place only if an implicit value of type math.Ordering[Value] is in scope.
   Shadowing
     This implicitly inherited member is shadowed by one or more members in this class.
     To access this member you can use a type ascription:

         (value: math.Ordered[Value]).<=(that)

   Definition Classes
     Ordered
4.  def >(that: Value): Boolean

   Returns true if `this` is greater than `that`.

   Returns true if `this` is greater than `that`.

   Implicit
     This member is added by an implicit conversion from Value to math.Ordered[Value] performed by method orderingToOrdered in scala.math.Ordered. This conversion will take place only if an implicit value of type math.Ordering[Value] is in scope.
   Shadowing
     This implicitly inherited member is shadowed by one or more members in this class.
     To access this member you can use a type ascription:

         (value: math.Ordered[Value]).>(that)

   Definition Classes
     Ordered
5.  def >=(that: Value): Boolean

   Returns true if `this` is greater than or equal to `that`.

   Returns true if `this` is greater than or equal to `that`.

   Implicit
     This member is added by an implicit conversion from Value to math.Ordered[Value] performed by method orderingToOrdered in scala.math.Ordered. This conversion will take place only if an implicit value of type math.Ordering[Value] is in scope.
   Shadowing
     This implicitly inherited member is shadowed by one or more members in this class.
     To access this member you can use a type ascription:

         (value: math.Ordered[Value]).>=(that)

   Definition Classes
     Ordered
6.  def compare(that: Value): Int

   Result of comparing `this` with operand `that`.

   Result of comparing `this` with operand `that`.

   Implement this method to determine how instances of A will be sorted.

   Returns `x` where:

   - `x < 0` when `this < that`
   - `x == 0` when `this == that`
   - `x > 0` when `this > that`
   Implicit
     This member is added by an implicit conversion from Value to math.Ordered[Value] performed by method orderingToOrdered in scala.math.Ordered. This conversion will take place only if an implicit value of type math.Ordering[Value] is in scope.
   Shadowing
     This implicitly inherited member is shadowed by one or more members in this class.
     To access this member you can use a type ascription:

         (value: math.Ordered[Value]).compare(that)

   Definition Classes
     Ordered
7.  def compareTo(that: Value): Int

   Result of comparing `this` with operand `that`.

   Result of comparing `this` with operand `that`.

   Implicit
     This member is added by an implicit conversion from Value to math.Ordered[Value] performed by method orderingToOrdered in scala.math.Ordered. This conversion will take place only if an implicit value of type math.Ordering[Value] is in scope.
   Shadowing
     This implicitly inherited member is shadowed by one or more members in this class.
     To access this member you can use a type ascription:

         (value: math.Ordered[Value]).compareTo(that)

   Definition Classes
     Ordered → Comparable

### Inherited from Serializable

### Inherited from java.io.Serializable

### Inherited from math.Ordered[Value]

### Inherited from Comparable[Value]

### Inherited from AnyRef

### Inherited from Any

### Inherited by implicit conversion orderingToOrdered from Value to math.Ordered[Value]

### Inherited by implicit conversion any2stringadd from Value to any2stringadd[Value]

### Inherited by implicit conversion StringFormat from Value to StringFormat[Value]

### Inherited by implicit conversion Ensuring from Value to Ensuring[Value]

### Inherited by implicit conversion ArrowAssoc from Value to ArrowAssoc[Value]

### Ungrouped